(function () {
    "use strict";

    angular.module('core').controller('transportadoraController', controller);
    controller.$inject = ['$scope', '$timeout', 'empresaService', '$alert'];

    function controller($scope, $timeout, empresaService, $alert) {
        $scope.initializeLayout('Transportadoras');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            forms: {},
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: {
                        Ativo: true,
                        CNPJ: '',
                        IndicaMatriz: null,
                        Matriz: { Nome: '' },
                        IndicaCliente: null,
                        IndicaFornecedor: null,
                        IndicaRepresentante: null,
                        IndicaTransportadora: true,
                        IndicaFilial: null,
                    },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
        };

        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    $scope.popups.add.data.IndicaTransportadora = true;
                    $scope.popups.add.data.Transportadora =  {Ativa : true} ;
                    empresaService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.popups.add.ativo = false;
                                $scope.popups.add.data = {};
                                $scope.refresh();

                                if (action == $scope.popups.add.saveAction.saveAndNew) {
                                    $scope.popups.add.steps.index = 0;
                                    $scope.popups.add.toggle();
                                }
                                else if (action == $scope.popups.add.saveAction.saveAndEdit) {
                                    $state.go("state-transportadora-edit", { id: response.Data.ID });
                                }
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                saveAction: {
                    save: 0, saveAndNew: 1, saveAndEdit: 2
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                        $('[ng-model$="popups.add.data.Codigo"]').focus();
                    }
                },
                prepare: function () {
                    empresaService
                        .prepareNew()
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                                $scope.popups.add.ativo = false;
                            } else {
                                
                                $scope.popups.add.data = response.Data;
                                $scope.popups.add.ativo = true;
                            }
                        },
                        function (_error) {
                            $scope.popups.add.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                steps: {
                    index: 0,
                    count: 2,
                    next: function () {


                        if ($scope.popups.add.steps.index == 0 && $scope.state.forms.form.cnpj.$viewValue != '' && $scope.state.forms.form.cnpj.$error.cnpj) {
                            $alert({ text: 'CNPJ inválido, por favor informe um CNPJ válido ! ', title: 'Atenção' });
                            return;
                        }


                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                    step0: {
                        checkCNPJ: function () {
                            /* Esta verificação chega se CNPJ já existe. 
                            Se já existe, recupera a empresa para que o usuário possa ir para o seu cadastro.
                            Se não existe, explica que o usuário pode continuar com o processo de inclusão.
                            */
                            $scope.popups.add.steps.step0.materiaIcon = '';
                            $scope.popups.add.steps.step0.mensagem = '';
                            $scope.popups.add.steps.step0.empresaExistente = {};

                            /* Se não preencheu o CNPJ apenas limpa o resultado da pesquisa anterior (já limpou) */
                            if ($scope.popups.add.data.CNPJ == '' || angular.isUndefined($scope.popups.add.data.CNPJ)) {
                                $alert({ text: 'CNPJ inválido, por favor informe um CNPJ válido ! ', title: 'Atenção' });
                                return;
                            };

                            if ($scope.popups.add.steps.index == 0 && $scope.state.forms.form.cnpj.$viewValue != '' && $scope.state.forms.form.cnpj.$error.cnpj) {
                                $alert({ text: 'CNPJ inválido, por favor informe um CNPJ válido ! ', title: 'Atenção' });
                                return;
                            };
                            $scope.state.salvando = true;

                            var args = { filtro: { CNPJ: $scope.popups.add.data.CNPJ, take: 1 } };
                            empresaService
                                .getAll(args)
                                .then(
                                function (response) {
                                    if (response.Status < 0) {
                                        $alert({ title: $scope.Title, text: response.Message });
                                    } else {
                                        if (response.Data.length > 0) {
                                            $scope.popups.add.steps.step0.materialIcon = 'pan_tool';
                                            $scope.popups.add.steps.step0.mensagem = "Este CNPJ já está cadastado em nossas bases de dados."
                                            $scope.popups.add.steps.step0.empresaExistente = response.Data[0];
                                        } else {
                                            $scope.popups.add.steps.step0.materialIcon = 'thumb_up';
                                            $scope.popups.add.steps.step0.mensagem = "CNPJ ainda não foi utilizado. Para continuar clique em 'avançar'."
                                        }
                                    }
                                    $scope.state.salvando = false;
                                },
                                function (_error) {
                                    $scope.state.salvando = false;
                                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                                });
                        },
                        materialIcon: '',
                        mensagem: '',
                        empresaExistente: {},
                    },
                    step1: {},
                    step2: {},
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            empresaService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            empresaService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            empresaService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.filtro.Ativo = null;
            $scope.state.filtro.args.filtro.CNPJ = '';
            $scope.state.filtro.args.filtro.IndicaMatriz = null;
            $scope.state.filtro.args.filtro.Matriz.Nome = '';
            $scope.state.filtro.args.filtro.IndicaCliente = null;
            $scope.state.filtro.args.filtro.IndicaFornecedor = null;
            $scope.state.filtro.args.filtro.IndicaRepresentante = null;
            $scope.state.filtro.args.filtro.IndicaTransportadora = true;
            $scope.state.filtro.args.filtro.IndicaFilial = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();